package com.company.mysupermenu.view.main;

import com.company.mysupermenu.view.myfirst.MyFirstView;
import com.company.mysupermenu.view.user.MySecondView;
import com.google.common.base.Strings;
import com.vaadin.flow.component.ClickEvent;
import com.vaadin.flow.router.Route;
import io.jmix.flowui.ViewNavigators;
import io.jmix.flowui.app.main.StandardMainView;
import io.jmix.flowui.component.image.JmixImage;
import io.jmix.flowui.kit.component.button.JmixButton;
import io.jmix.flowui.view.Subscribe;
import io.jmix.flowui.view.ViewController;
import io.jmix.flowui.view.ViewDescriptor;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;

@Route("")
@ViewController(id = "MainView")
@ViewDescriptor(path = "main-view.xml")
public class MainView extends StandardMainView {

    @Autowired
    private ViewNavigators viewNavigators;

    @Override
    protected String getTitleFromOpenedView() {
        String titleFromOpenedView = super.getTitleFromOpenedView();
        return Strings.isNullOrEmpty(titleFromOpenedView)
                ? "Dashboard"
                : titleFromOpenedView;
    }

    @Subscribe(id = "lineSeriesImage", subject = "clickListener")
    public void onLineSeriesImageClick(final ClickEvent<JmixImage<?>> event) {
        viewNavigators.view(this, MyFirstView.class)
                .navigate();
    }

    @Subscribe(id = "barSeriesImage", subject = "clickListener")
    public void onBarSeriesImageClick(final ClickEvent<JmixImage<?>> event) {
        viewNavigators.view(this, MySecondView.class)
                .navigate();
    }

    @Subscribe(id = "pieSeriesImage", subject = "clickListener")
    public void onPieSeriesImageClick(final ClickEvent<JmixImage<?>> event) {
        viewNavigators.view(this, MyFirstView.class)
                .navigate();
    }

    @Subscribe(id = "mainViewButton", subject = "clickListener")
    public void onMainViewButtonClick(final ClickEvent<JmixButton> event) {
        viewNavigators.view(this, MainView.class)
                .navigate();
    }
}
